'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('codemirror/mode/javascript/javascript');

require('codemirror/mode/jsx/jsx');

require('codemirror/addon/runmode/runmode');

var _CodeEditor = require('./CodeEditor');

var _CodeEditor2 = _interopRequireDefault(_CodeEditor);

var _parseHTML2 = require('./parseHTML');

var _parseHTML3 = _interopRequireDefault(_parseHTML2);

var _Preview = require('./Preview');

var _Preview2 = _interopRequireDefault(_Preview);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');
var PropTypes = require('prop-types');
var ReactDOM = require('react-dom');

var _require = require('react-markdown-reader'),
    Markdown = _require.Markdown;

var CodeView = function (_React$Component) {
  _inherits(CodeView, _React$Component);

  function CodeView(props) {
    _classCallCheck(this, CodeView);

    var _this = _possibleConstructorReturn(this, (CodeView.__proto__ || Object.getPrototypeOf(CodeView)).call(this, props));

    _initialiseProps.call(_this);

    var _parseHTML = (0, _parseHTML3.default)(props.children || props.source),
        code = _parseHTML.code,
        beforeHTML = _parseHTML.beforeHTML,
        afterHTML = _parseHTML.afterHTML;

    _this.state = {
      beforeHTML: beforeHTML,
      afterHTML: afterHTML,
      code: code,
      showCode: props.showCode,
      hasError: false,
      errorMessage: null,
      exampleList: []
    };
    _this.executeCode = _this.executeCode.bind(_this);

    setTimeout(function () {
      _this.executeCode();
    }, props.delay);
    return _this;
  }

  _createClass(CodeView, [{
    key: 'executeCode',
    value: function executeCode() {
      var _this2 = this;

      var _props = this.props,
          babelTransformOptions = _props.babelTransformOptions,
          dependencies = _props.dependencies;
      var code = this.state.code;

      var originalRender = ReactDOM.render;
      var hasError = false;
      var exampleList = this.state.exampleList;

      Object.keys(code).forEach(function (item) {
        ReactDOM.render = function (element) {
          exampleList.push(_defineProperty({}, item, element));
          _this2.setState({
            exampleList: exampleList
          });
        };
        try {
          var transformCode = window.Babel.transform(code[item][0], babelTransformOptions).code;
          var statement = '';

          if (dependencies) {
            Object.keys(dependencies).forEach(function (key) {
              statement += 'var ' + key + '= dependencies.' + key + ';\n ';
            });
          }

          /* eslint-disable */
          eval(statement + ' ' + transformCode);
          /* eslint-enable */
        } catch (err) {
          hasError = true;
          console.error(err);
        } finally {
          ReactDOM.render = originalRender;
          if (!hasError) {
            _this2.forceUpdate();
          }
        }
      });
    }
  }, {
    key: 'renderExample',
    value: function renderExample(example) {
      var _state = this.state,
          hasError = _state.hasError,
          errorMessage = _state.errorMessage;

      return React.createElement(
        _Preview2.default,
        { hasError: hasError, errorMessage: errorMessage, onError: this.handleError },
        React.createElement(
          'div',
          null,
          example || React.createElement(
            'div',
            null,
            'Loading...'
          )
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          className = _props2.className,
          style = _props2.style;
      var _state2 = this.state,
          beforeHTML = _state2.beforeHTML,
          afterHTML = _state2.afterHTML;


      return React.createElement(
        'div',
        { className: className, style: style },
        React.createElement(
          Markdown,
          null,
          beforeHTML
        ),
        this.renderExampleAll(),
        React.createElement(
          Markdown,
          null,
          afterHTML
        )
      );
    }
  }]);

  return CodeView;
}(React.Component);

CodeView.propTypes = {
  classPrefix: PropTypes.string,
  delay: PropTypes.number,
  showCode: PropTypes.bool,
  source: PropTypes.string,
  children: PropTypes.string,
  dependencies: PropTypes.object,
  babelTransformOptions: PropTypes.object,
  buttonClassName: PropTypes.string,
  showCodeIcon: PropTypes.node
};
CodeView.defaultProps = {
  delay: 0,
  babelTransformOptions: {
    presets: ['stage-0', 'react', 'es2015']
  },
  readOnly: true
};

var _initialiseProps = function _initialiseProps() {
  var _this3 = this;

  this.handleCodeChange = function (val, key) {
    var code = _this3.state.code;

    code[key] = val;
    _this3.setState({
      hasError: false,
      errorMessage: null,
      code: code,
      exampleList: []
    }, function () {
      _this3.executeCode();
    });
  };

  this.handleShowCode = function () {
    var showCode = !_this3.state.showCode;
    _this3.setState({ showCode: showCode });
  };

  this.handleError = function (error) {
    _this3.setState({
      hasError: true,
      errorMessage: error.message
    });
  };

  this.renderExampleAll = function () {
    var _props3 = _this3.props,
        showCodeIcon = _props3.showCodeIcon,
        buttonClassName = _props3.buttonClassName,
        classPrefix = _props3.classPrefix,
        readOnly = _props3.readOnly;
    var code = _this3.state.code;
    var exampleList = _this3.state.exampleList;


    var exampleListDom = exampleList && exampleList.map(function (item) {
      var key = Object.keys(item).join();
      return React.createElement(
        'div',
        { className: 'code-view-wrapper', key: key },
        _this3.renderExample(item[key]),
        React.createElement(_CodeEditor2.default, {
          lineNumbers: true,
          $key: key,
          onChange: _this3.handleCodeChange,
          theme: 'base16-light',
          code: code,
          buttonClassName: buttonClassName,
          showCodeIcon: showCodeIcon,
          classPrefix: classPrefix,
          readOnly: readOnly
        })
      );
    });
    return exampleListDom;
  };
};

exports.default = CodeView;